unit ApiDlgU;
// Use pre-Delphi Windows programming to display note-editing
// dialog - this saves 150KB from DLL size!

interface
USES Windows, Messages, SysUtils;

function EdNote(const fName : String; VAR vNote : String) : Boolean;

implementation
{$R apidlg.RES}
{$I apidlg.INC}
VAR
  gCaption : ARRAY[0..MAX_PATH] OF Char;
  gLabel   : ARRAY[0..MAX_PATH] OF Char;
  gEdit    : ARRAY[0..MAX_PATH] OF Char;

function DialogProc(hwndDlg: HWnd; Msg: UINT; wParam: wParam;
  lParam: LPARAM) : Bool; Far; stdcall;
begin
  Result := FALSE;
  CASE Msg OF
    WM_INITDIALOG : begin
      // initialize caption, filename label, and note memo
      SetWindowText(hWndDlg, gCaption);
      SetDlgItemText(hWndDlg, IDC_FileName, gLabel);
      SetDlgItemText(hWndDlg, IDC_NoteMemo, gEdit);
      // limit memo text to 255 chars
      SendDlgItemMessage(hWndDlg, IDC_NoteMemo, EM_LIMITTEXT,
        MAX_PATH, 0);
      Result := TRUE;
    end;
    WM_COMMAND : CASE wParam OF
      IDOK : begin
        // return length of note
        EndDialog(hwndDlg, GetDlgItemText(hwndDlg, IDC_NOTEMEMO,
          gEdit, MAX_PATH));
        Result := TRUE;
      end;
      IDCANCEL : begin
        // return -1
        EndDialog(hwndDlg, -1);
        Result := TRUE;
      end;
    end;
  END;
  Result := FALSE;
end;

function EdNote(const fName : String; VAR vNote : String) : Boolean;
VAR N : Integer;
begin
  IF fName='' THEN
    begin
      StrPCopy(gCaption, 'Append note...');
      StrPCopy(gLabel,'(multiple files selected)');
    end
  ELSE
    begin
      StrPCopy(gCaption, 'Add/Edit note for...');
      StrPLCopy(gLabel, fName, MAX_PATH);
    end;
  StrPLCopy(gEdit, vNote, MAX_PATH);
  IF DialogBox(HInstance, MakeIntResource(NoteDialog), 0,
    @DialogProc) >= 0 THEN
    BEGIN
      vNote := StrPas(gEdit);
      FOR N := 1 TO Length(vNote) DO
        IF vNote[N] < #32 THEN
          vNote[N] := #32;
      vNote  := Trim(vNote);
      Result := True;
    END
  ELSE Result := False;
end;
end.
