// FIGNU05.TXT is this entire file
library en_dll;

uses ShellObj, Ole2, Windows, Registry, SysUtils,
  exshellu, expsubcl;

// The DLLGetClassObject function you're about to see is true.
// Only the names have been changed to protect the innocent.
function DllGetClassObject(const RequestedClassID: TCLSID;
  const RequestedInterfaceID: TGUID; VAR ReturnedObject):
  HResult;  StdCall; Export;
VAR MyClassFactory : IMyClassFactory;
BEGIN
  Pointer(ReturnedObject) := NIL;
  // Make sure Explorer's asking for OUR class
  IF NOT IsEqualIID(CLSID_MyShellExtension, RequestedClassID) THEN
    begin
      Result := CLASS_E_CLASSNOTAVAILABLE;
      Exit;
    end;
  // Create the class factory - unless out of memory
  try
    MyClassFactory := IMyClassFactory.Create;
    // Get the requested interface
    Result := MyClassFactory.QueryInterface(RequestedInterfaceID,
      ReturnedObject);
    IF FAILED(Result) then MyClassFactory.Free;
  except
    Result := E_OUTOFMEMORY;
    Exit;
  end;
END;

function DLLCanUnloadNow: hResult; StdCall; Export;
begin
  IF (LockCount=0) AND (DllRefCount=0) THEN
    Result := S_OK
  ELSE Result := S_FALSE;
end;

function ExpNote_Activate : THandle; StdCall; Export;
VAR buffer : ARRAY[0..MAX_PATH] OF Char;
begin
  Result := CBT_Activate;
  WITH TRegistry.Create DO
    try
      RootKey := HKEY_CLASSES_ROOT;
      // install the context menu handler
      OpenKey('\*\shellex\ContextMenuHandlers\NJRContextMenu', True);
      WriteString('', String_MyShellExtension);
      OpenKey('\directory\shellex\ContextMenuHandlers\'+
        'NJRContextMenu', True);
      WriteString('', String_MyShellExtension);
      // install the copy hook handler
      OpenKey('\*\shellex\CopyHookHandlers\NJRCopyHook', True);
      WriteString('', String_MyShellExtension);
      OpenKey('\directory\shellex\CopyHookHandlers\NJRCopyHook',
        True);
      WriteString('', String_MyShellExtension);
      // now register the shell extension itself
      OpenKey('\CLSID\'+String_MyShellExtension, True);
      WriteString('', 'ExpNotes Shell Extension');
      OpenKey('\CLSID\'+String_MyShellExtension+ '\InprocServer32',
        True);
      GetModuleFilename(hInstance, buffer, MAX_PATH);
      WriteString('', StrPas(Buffer));
      WriteString('ThreadingModel', 'Apartment');
    finally
      free;
    end;
end;

PROCEDURE ExpNote_DeActivate(holdMap: THandle); Stdcall; Export;
begin
  WITH TRegistry.Create DO
    try
      RootKey := HKEY_CLASSES_ROOT;
      DeleteKey('\CLSID\'+String_MyShellExtension);
      DeleteKey('\*\shellex\ContextMenuHandlers\NJRContextMenu');
      DeleteKey('\Directory\shellex\ContextMenuHandlers\'+
        'NJRContextMenu');
      DeleteKey('\*\shellex\CopyHookHandlers\NJRCopyHook');
      DeleteKey('\Directory\shellex\CopyHookHandlers\NJRCopyHook');
    finally
      free;
    end;
  CBT_DeActivate(holdMap);
end;

Exports
  DllGetClassObject   name 'DllGetClassObject' resident,
  DllCanUnloadNow     name 'DllCanUnloadNow' resident,
  ExpNote_Activate    name 'ExpNote_Activate',
  ExpNote_DeActivate  name 'ExpNote_DeActivate';

begin
end.

